#!/bin/bash
# Copyright (C) 2008 - 2011 vortexbox.org
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

CDDEVICE="/dev/sr0"

function echolog {
echo "`date +'%m/%d/%Y %H:%M:%S'` - $1"
}
echo "" >> /var/log/cdrip.log

echolog "<b>Restarting Auto Ripper...</b>" >> /var/log/cdrip.log
echolog "Ripping from $CDDEVICE" >> /var/log/cdrip.log
echolog "`/usr/bin/cd-info --no-cddb --no-analyze --no-tracks | grep Vendor`" >> /var/log/cdrip.log
echolog "`/usr/bin/cd-info --no-cddb --no-analyze --no-tracks | grep Model`" >> /var/log/cdrip.log
echolog "`/usr/bin/cd-info --no-cddb --no-analyze --no-tracks | grep Revision`" >> /var/log/cdrip.log

echo "" >> /var/log/cdrip.log

if ping -c 1 -w 5 "google.com" &>/dev/null ; then
	echolog "Using your Internet connection to get metadata for ripped disks." >> /var/log/cdrip.log
else
	echolog "<b>Internet not avalible.</b> No track or disk info will be avalible." >> /var/log/cdrip.log
	echolog "(Your DNS may not be working)" >> /var/log/cdrip.log
fi	

echo "" >> /var/log/cdrip.log

while true
do
CDSTATUS=`/opt/vortexbox/checkcd $CDDEVICE`

 if [ "$CDSTATUS" = "ready" ]; then
   CDINFO=`/usr/bin/cd-info --no-cddb --no-analyze --no-device-info --no-tracks | grep "Disc mode is listed as" | cut -d \: -f 2`
   CDTYPE=${CDINFO/ /}

   # If the disk is an audio CD rip using ripit
   if [ "$CDTYPE" = "CD-DA" ]; then
     echolog "Optical disk detected - type : Audio CD" >> /var/log/cdrip.log
	 /usr/bin/ripit -d $CDDEVICE
	 /opt/vortexbox/mirror_manager &
	 /usr/bin/eject $CDDEVICE
	 /opt/vortexbox/checkcd $CDDEVICE
   fi

   # If the disk is a DVD rip using makemkv
   if [ "$CDTYPE" = "DVD-ROM" ]; then
     echolog "Optical disk detected - type : DVD" >> /var/log/cdrip.log

	 if [ ! -f /usr/bin/ffmpeg ]; then
		echolog "Installing (required) ffmpg ..." >> /var/log/cdrip.log
		/usr/local/sbin/setup-mplayer >> /var/log/cdrip.log
	 fi

	 /usr/bin/php /opt/vortexbox/docd_helper.php >> /var/log/cdrip.log

	 /usr/bin/eject $CDDEVICE
	 /opt/vortexbox/checkcd $CDDEVICE
	 echolog "Done." >> /var/log/cdrip.log
   fi
   
   # If the disk is a Blu-Ray rip using makemkv
   if [ "$CDTYPE" = "CD-DATA (Mode 1)" ]; then
     echolog "Optical disk detected - type : Blu-ray" >> /var/log/cdrip.log

	 if [ ! -f /usr/bin/ffmpeg ]; then
		echolog "Installing (required) ffmpg ..." >> /var/log/cdrip.log
		/usr/local/sbin/setup-mplayer >> /var/log/cdrip.log
	 fi

	 /usr/bin/php /opt/vortexbox/docd_helper.php >> /var/log/cdrip.log

	 /usr/bin/eject $CDDEVICE
	 /opt/vortexbox/checkcd $CDDEVICE
	 echolog "Done." >> /var/log/cdrip.log
   fi   
 fi

/opt/vortexbox/checkcd $CDDEVICE
 
sleep 2

done
